__float128 angle_restrict_posq(const __float128 theta)
{
  /* synthetic extended precision constants */
  const __float128 P1 = 3.1415926535897930000000000000000000000000Q;
  const __float128 P2 = 0.2384626433832790000000000000000000000000e-15Q;
  const __float128 P3 = 0.5028841971693990000000000000000000000000e-30Q;
  //const __float128 P4 = 0.375105820974944e-45L;
  /*
  const __float128 P1 = 4 * 7.85398125648498535156e-01L;
  const __float128 P2 = 4 * 3.77489470793079817668e-08L;
  const __float128 P3 = 4 * 2.69515142907905952645e-15L;*/
  const __float128 TwoPi = 2*(P1 + P2 + P3);

  const __float128 y = 2*floorq(theta/TwoPi);

  __float128 r = (((theta - y*P1) - y*P2) - y*P3);

  if(r > TwoPi) {r = (((r-2*P1)-2*P2)-2*P3); }  /* r-TwoPi */
  else if (r < 0) { /* may happen due to FP rounding */
    r = (((r+2*P1)+2*P2)+2*P3); /* r+TwoPi */
  }

  return r;
};




static __float128 zeta_2n_minus1q[40]={
0.6449340668482264364724151666460251892189Q,
0.08232323371113819151600369654116790277475Q,
0.01734306198444913971451792979092052790182Q,
0.004077356197944339378685238508652465258961Q, 
0.0009945751278180853371459589003190170060195Q,
0.0002460865533080482986379980477396709604161Q,
0.00006124813505870482925854510513533374748170Q,
0.00001528225940865187173257148763672202323739Q,
3.817293264999839856461644621939730454697e-6Q, 
9.539620338727961131520386834493459437942e-7Q, 
2.384505027277329900036481867529949350418e-7Q, 
5.960818905125947961244020793580122750392e-8Q, 
1.490155482836504123465850663069862886479e-8Q, 
3.725334024788457054819204018402423232893e-9Q, 
9.313274324196681828717647350212198135680e-10Q, 
2.328311833676505492001455975940495024830e-10Q, 
5.820772087902700889243685989106305417312e-11Q, 
1.455192189104198423592963224531842098381e-11Q, 
3.637979547378651190237236355873273512646e-12Q,
9.094947840263889282533118386949087538600e-13Q,
2.273736845824652515226821577978691213830e-13Q, 
5.684341987627585609277182967524068553057e-14Q, 
1.421085482803160676983430714173953767870e-14Q, 
3.552713691337113673298469534059342992146e-15Q, 
8.881784210930815903096091386391386325609e-16Q, 
2.220446050798041983999320094204653964237e-16Q, 
5.551115124845481243723736590509430281672e-17Q, 
1.387778780972523276283909490650022190772e-17Q, 
3.469446952165922624744271496109334621950e-18Q, 
8.673617380119933728342055067342951487907e-19Q,
2.168404344997219785013910168320984576157e-19Q,
5.421010862456645410918700404388633715063e-20Q,
1.355252715610116458148523399682692832898e-20Q,
3.388131789020796818085703100450836834031e-21Q,
8.470329472546998348246992609182167522284e-22Q,
2.117582368136194731844209439818002586942e-22Q,
5.293955920339870323813912302918505586638e-23Q,
1.323488980084899080309451025094498968432e-23Q,
3.308722450212171588946956384314404809276e-24Q,
8.271806125530344403671105616744072404010e-25Q
};




__float128 clausen_seriesq(__float128 theta)
{
   int i;
   __float128 tmp=0.0Q;
   __float128 x = theta*theta/(4.0Q*Pi*Pi);
   __float128 xn = 1.0Q;
   for(i=0;i<40;i++)
   {
       xn = xn*x; 
       tmp = tmp + zeta_2n_minus1q[i]*xn/((__float128)(i+1)*(2*i+3) );
    };
    return tmp;
};






__float128 clausenq(__float128 x)
{
  const __float128 x_cut = Pi * MY_LDBL_EPSILON;

  __float128 sgn = 1.0Q;
  __float128 result;  

  if(x < 0.0) {
    x   = -x;
    sgn = -1.0Q;
  };

  /* Argument reduction to [0, 2pi) */
  x = angle_restrict_posq(x);

  /* Further reduction to [0,pi) */
  if(x > Pi) {
    /* simulated extra precision: 2PI = p0 + p1 */
    x = 2.0Q*Pi-x;
    sgn = -sgn;
  }

  if(x == 0.0) {
    result = 0.0Q;
  }
  else if(x < x_cut) {
    result = x * (1.0Q - logq(x));
  }
  else {
      
      result = x * (3.0Q - logq(x*(1.0Q-x*x/(4.0Q*Pi*Pi))) - 2.0Q*Pi/x*logq((2.0Q*Pi+x)/(2.0Q*Pi-x)) + clausen_seriesq(x));
    };

  result *= sgn;

  return result;
};